# LLVM: `llvm-prof` tool

### NAME

`llvm-prof`

### SYNOPSIS

`llvm-prof [options] [bytecode file] [LLVM passes]`

### DESCRIPTION

The `llvm-prof` tool reads in an '`llvmprof.out`' file, a bytecode file for the program, and produces a human readable report, suitable for determining where the program hotspots are.

This program is often used in conjunction with the `utils/profile.sh` script. This script automatically instruments a program, runs it with the JIT, then runs `llvm-prof` to format a report. To get more information about `utils/profile.sh`, execute it with the `--help` option.

### OPTIONS

- `--annotated-llvm` or `-A`
  In addition to the normal report printed, print out the code for the program, annotated we execution frequency information. This can be particularly useful when trying to visualize how frequently basic blocks are executed. This is most useful with basic block profiling information or better.

- `--print-all-code`
  Using this option enables the `--annotated-llvm` option, but it prints the entire module, instead of just the most commonly executed functions.

### EXIT STATUS

`llvm-prof` returns 1 if it cannot load the bytecode file or the profile information, otherwise it exits with zero.

Maintained by the LLVM Team.